/*
 * free_bgrotd_conf.c
 * Free a BGROTD_CONF struct
 * bgrot project
 * $Fuller: myprograms/bgrot/common/mem/free_bgrotd_conf.c,v 1.3 2003/03/09 13:23:15 fullermd Exp $
 */

#include <stdlib.h>

#include <bgrot.h>


/* free_bgrotd_conf(): Free a BGROTD_CONF struct */
void
free_bgrotd_conf(BGROTD_CONF *tofree)
{
	if(tofree == NULL)
		return;

	if(tofree->list_index != NULL)
		free_lindex(tofree->list_index);

	if(tofree->sel_list!= NULL)
		free_imglist(tofree->sel_list);

	if(tofree->conf_override!= NULL)
		free_ilconf(tofree->conf_override);

	free(tofree->basedir);
	free(tofree->rundir);
	free(tofree->listdir);
	free(tofree);
}
