/*
 * display_image_thr.c
 * Display one image and exit
 * bgrot project
 * $Fuller: myprograms/bgrot/server/display_image_thr.c,v 1.4 2003/03/10 02:08:05 fullermd Exp $
 */

#include <sys/time.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

#include <bgrot.h>
#include <bgrotd.h>


/* Dive in */
void *
display_image_thr(void *imgin)
{
	IMGENT *thisimg;
	int fret;
	pid_t wret;

	thisimg = (IMGENT *)imgin;
	fret = vfork();

	if(fret==-1)
	{
		/*
		 * We're slightly limited in choices here.  [v]fork() fails
		 * generally because the process limit has been reached.  We're
		 * going to consider it a temporary failure and just return().
		 * Note that this will leave the cur_img pointer screwed up.
		 * Well, tough shit.
		 */
		return(NULL);
	}
	else if(fret>0)
	{
		/* We're the parent */
		free_imgent(imgin);
		sleep(XV_WAIT);
		wret = waitpid(fret, NULL, WNOHANG);
		while(wret != fret)
		{
			/* It's not done yet.  Die, xv, die! */
			kill(fret, SIGKILL);
			wret = waitpid(fret, NULL, WNOHANG);
			sleep(1);
		}
		return(NULL);
	}
	else
	{
		/* We're the child */
		/* Use execlp() to use $PATH */
		/* XXX Allow variable args down the road */
		execlp(XV_PROGNAME, XV_PROGNAME, "-root", "-quit",
				"+nore", thisimg->fname, NULL);
		/* If we're still here, we're screwed up */
		return(NULL);
	}

	/* NOTREACHED */
	exit(1);
}
